package editor.gui;

import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComponent;

import javax.swing.WindowConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import org.jdesktop.layout.GroupLayout;
import org.jdesktop.layout.LayoutStyle;

import editor.model.Exit;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JTextField;
import javax.swing.ListModel;


/**
 * Editor panel for exits of the game location
 * @author Frank Bruns
 *
 */
public class ExitsPanel extends javax.swing.JPanel {
	private JList listExits;
	private JLabel labelExitName;
	private JTextField textExitBshName;
	private JTextField textPosX;
	private JTextField textPosY;
	private JLabel labelDestination;
	private JButton buttonAddExit;
	private JTextField textDestination;
	private JTextField textNewY;
	private JLabel labelNewY;
	private JTextField textNewX;
	private JLabel jLabel1;
	private JLabel labelNewX;
	private JTextField textHeight;
	private JLabel labelWidth;
	private JLabel labelHeight;
	private JTextField textWidth;
	private JLabel labelY;
	private JLabel labelX;
	private JLabel labelPosXY;
	private JLabel labelExitBshName;
	private JTextField textExitName;
	
	private Vector<Exit> exits = null;

	/**
	* Auto-generated main method to display this 
	* JPanel inside a new JFrame.
	*/
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.getContentPane().add(new ExitsPanel());
		frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		frame.pack();
		frame.setVisible(true);
	}
	
	public ExitsPanel() {
		super();
		initGUI();
		this.exits = new Vector<Exit>();
	}
	
	private void initGUI() {
		try {
			GroupLayout thisLayout = new GroupLayout((JComponent) this);
			this.setLayout(thisLayout);
			setPreferredSize(new Dimension(400, 300));
			{
				listExits = new JList();
				listExits.addListSelectionListener(new ListSelectionListener() {
					public void valueChanged(ListSelectionEvent evt) {
						listExitsValueChanged(evt);
					}
				});
			}
			{
				textExitName = new JTextField();
			}
			{
				labelExitName = new JLabel();
				labelExitName.setText("Exit name:");
			}
			{
				labelExitBshName = new JLabel();
				labelExitBshName.setText("Exit beanshell name:");
			}
			{
				textExitBshName = new JTextField();
			}
			{
				labelPosXY = new JLabel();
				labelPosXY.setText("Position:");
			}
			{
				textPosX = new JTextField();
			}
			{
				textPosY = new JTextField();
			}
			{
				labelX = new JLabel();
				labelX.setText("x:");
			}
			{
				labelY = new JLabel();
				labelY.setText("y:");
			}
			{
				labelWidth = new JLabel();
				labelWidth.setText("Width:");
			}
			{
				textWidth = new JTextField();
			}
			{
				labelHeight = new JLabel();
				labelHeight.setText("Height:");
			}
			{
				textHeight = new JTextField();
			}
			{
				labelNewX = new JLabel();
				labelNewX.setText("New position:");
			}
			{
				jLabel1 = new JLabel();
				jLabel1.setText("x:");
			}
			{
				textNewX = new JTextField();
			}
			{
				labelNewY = new JLabel();
				labelNewY.setText("y:");
			}
			{
				textNewY = new JTextField();
			}
			{
				labelDestination = new JLabel();
				labelDestination.setText("Destination location:");
			}
			{
				textDestination = new JTextField();
			}
			{
				buttonAddExit = new JButton();
				buttonAddExit.setText("Add exit");
				buttonAddExit.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent evt) {
						buttonAddExitActionPerformed(evt);
					}
				});
			}
				thisLayout.setHorizontalGroup(thisLayout.createSequentialGroup()
			    .addContainerGap()
			    .add(thisLayout.createParallelGroup()
			        .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			            .add(labelExitName)
			            .add(48))
			        .add(GroupLayout.LEADING, labelExitBshName)
			        .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			            .add(labelPosXY)
			            .add(58))
			        .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			            .add(labelWidth)
			            .add(67))
			        .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			            .add(labelHeight)
			            .add(64))
			        .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			            .add(labelNewX)
			            .add(34))
			        .add(GroupLayout.LEADING, labelDestination))
			    .add(27)
			    .add(thisLayout.createParallelGroup()
			        .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			            .add(textExitName, GroupLayout.PREFERRED_SIZE, 101, GroupLayout.PREFERRED_SIZE)
			            .addPreferredGap(LayoutStyle.RELATED))
			        .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			            .add(textExitBshName, GroupLayout.PREFERRED_SIZE, 101, GroupLayout.PREFERRED_SIZE)
			            .addPreferredGap(LayoutStyle.RELATED))
			        .add(thisLayout.createSequentialGroup()
			            .add(thisLayout.createParallelGroup()
			                .add(GroupLayout.LEADING, labelX)
			                .add(GroupLayout.LEADING, jLabel1))
			            .addPreferredGap(LayoutStyle.RELATED)
			            .add(thisLayout.createParallelGroup()
			                .add(thisLayout.createSequentialGroup()
			                    .add(thisLayout.createParallelGroup()
			                        .add(GroupLayout.LEADING, textPosX, GroupLayout.PREFERRED_SIZE, 27, GroupLayout.PREFERRED_SIZE)
			                        .add(GroupLayout.LEADING, textNewX, GroupLayout.PREFERRED_SIZE, 27, GroupLayout.PREFERRED_SIZE))
			                    .add(12)
			                    .add(thisLayout.createParallelGroup()
			                        .add(GroupLayout.LEADING, labelY)
			                        .add(GroupLayout.LEADING, labelNewY))
			                    .add(12)
			                    .add(thisLayout.createParallelGroup()
			                        .add(GroupLayout.LEADING, textPosY, GroupLayout.PREFERRED_SIZE, 26, GroupLayout.PREFERRED_SIZE)
			                        .add(GroupLayout.LEADING, textNewY, GroupLayout.PREFERRED_SIZE, 27, GroupLayout.PREFERRED_SIZE)))
			                .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			                    .add(13)
			                    .add(buttonAddExit, GroupLayout.PREFERRED_SIZE, 75, GroupLayout.PREFERRED_SIZE))))
			        .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			            .add(textWidth, GroupLayout.PREFERRED_SIZE, 101, GroupLayout.PREFERRED_SIZE)
			            .addPreferredGap(LayoutStyle.RELATED))
			        .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			            .add(textHeight, GroupLayout.PREFERRED_SIZE, 101, GroupLayout.PREFERRED_SIZE)
			            .addPreferredGap(LayoutStyle.RELATED))
			        .add(GroupLayout.LEADING, textDestination, GroupLayout.PREFERRED_SIZE, 104, GroupLayout.PREFERRED_SIZE))
			    .add(25)
			    .add(listExits, GroupLayout.PREFERRED_SIZE, 121, GroupLayout.PREFERRED_SIZE)
			    .addContainerGap());
				thisLayout.setVerticalGroup(thisLayout.createSequentialGroup()
			    .addContainerGap()
			    .add(thisLayout.createParallelGroup()
			        .add(GroupLayout.LEADING, listExits, GroupLayout.PREFERRED_SIZE, 276, GroupLayout.PREFERRED_SIZE)
			        .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			            .add(thisLayout.createParallelGroup()
			                .add(GroupLayout.LEADING, textExitName, GroupLayout.PREFERRED_SIZE, 18, GroupLayout.PREFERRED_SIZE)
			                .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			                    .add(labelExitName)
			                    .addPreferredGap(LayoutStyle.RELATED)))
			            .addPreferredGap(LayoutStyle.RELATED)
			            .add(thisLayout.createParallelGroup()
			                .add(GroupLayout.BASELINE, textExitBshName, GroupLayout.PREFERRED_SIZE, 21, GroupLayout.PREFERRED_SIZE)
			                .add(GroupLayout.BASELINE, labelExitBshName))
			            .add(14)
			            .add(thisLayout.createParallelGroup()
			                .add(GroupLayout.BASELINE, textPosX, GroupLayout.PREFERRED_SIZE, 21, GroupLayout.PREFERRED_SIZE)
			                .add(GroupLayout.BASELINE, labelPosXY)
			                .add(GroupLayout.BASELINE, textPosY, GroupLayout.PREFERRED_SIZE, 21, GroupLayout.PREFERRED_SIZE)
			                .add(GroupLayout.BASELINE, labelX)
			                .add(GroupLayout.BASELINE, labelY))
			            .addPreferredGap(LayoutStyle.RELATED)
			            .add(thisLayout.createParallelGroup()
			                .add(GroupLayout.BASELINE, textWidth, GroupLayout.PREFERRED_SIZE, 22, GroupLayout.PREFERRED_SIZE)
			                .add(GroupLayout.BASELINE, labelWidth))
			            .addPreferredGap(LayoutStyle.RELATED)
			            .add(thisLayout.createParallelGroup()
			                .add(GroupLayout.LEADING, textHeight, GroupLayout.PREFERRED_SIZE, 23, GroupLayout.PREFERRED_SIZE)
			                .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			                    .add(9)
			                    .add(labelHeight)))
			            .add(17)
			            .add(thisLayout.createParallelGroup()
			                .add(GroupLayout.LEADING, thisLayout.createParallelGroup()
			                    .add(GroupLayout.BASELINE, textNewX, GroupLayout.PREFERRED_SIZE, 23, GroupLayout.PREFERRED_SIZE)
			                    .add(GroupLayout.BASELINE, jLabel1)
			                    .add(GroupLayout.BASELINE, labelNewY)
			                    .add(GroupLayout.BASELINE, textNewY, GroupLayout.PREFERRED_SIZE, 23, GroupLayout.PREFERRED_SIZE))
			                .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			                    .add(9)
			                    .add(labelNewX)))
			            .add(15)
			            .add(thisLayout.createParallelGroup()
			                .add(GroupLayout.BASELINE, textDestination)
			                .add(GroupLayout.BASELINE, labelDestination))
			            .add(42)
			            .add(buttonAddExit)))
			    .addContainerGap());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * Returns a vector containing the exits created with the editor
	 * @return vector with exits
	 */
	public Vector<Exit> getExitList()
	{
		return this.exits;
	}
	
	/**
	 * Adds a new exit to the list
	 * @param evt
	 */
	private void buttonAddExitActionPerformed(ActionEvent evt) 
	{
		Exit exit = new Exit(this.textExitName.getText(),
				this.textExitBshName.getText(),
				this.textPosX.getText(),
				this.textPosY.getText(),
				this.textWidth.getText(),
				this.textHeight.getText(),
				this.textNewX.getText(),
				this.textNewY.getText(),
				this.textDestination.getText());
		
		// add exit to the list of exits
		this.exits.add(exit);
		
		// create a data model with the exit names for displaying in
		// the JList
		String[] model = new String[this.exits.size()];
		for(int i=0; i<this.exits.size(); i++)
		{
			model[i] = this.exits.get(i).getName();
		}
		ListModel listExitsModel = new DefaultComboBoxModel(model);
		this.listExits.setModel(listExitsModel);
	}
	
	/**
	 * Sets the data of the currently selected list item to 
	 * according text fields
	 * @param evt
	 */
	private void listExitsValueChanged(ListSelectionEvent evt) {
		// find the exit object that is corresponding to 
		// the selected list item
		String itemName = (String)this.listExits.getSelectedValue();
		final Exit selectedExit = this.findExit(itemName);
		
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				textExitName.setText(selectedExit.getName());
				textExitBshName.setText(selectedExit.getBshName());
				textPosX.setText(selectedExit.getX());
				textPosY.setText(selectedExit.getY());
				textWidth.setText(selectedExit.getWidth());
				textHeight.setText(selectedExit.getHeight());
				textNewX.setText(selectedExit.getNewX());
				textNewY.setText(selectedExit.getNewY());
				textDestination.setText(selectedExit.getDestination());
			}
		});	
	}
	
	/**
	 * Helper method to find the corresponding exit to the specified 
	 * name
	 * @param name name of the exit to find
	 * @return exit with the specified name
	 */
	private Exit findExit(String name)
	{
		for(Exit e : this.exits)
		{
			if(e.getName().equals(name)) return e;
		}
		
		return null;
	}

}
