package editor.gui;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JComponent;

import javax.swing.JSeparator;
import javax.swing.JTabbedPane;

import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.dom4j.io.OutputFormat;
import org.dom4j.io.XMLWriter;
import org.jdesktop.layout.GroupLayout;
import org.jdesktop.layout.LayoutStyle;

import xml.LocationExporter;

import editor.model.Exit;

import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JMenu;
import javax.swing.JMenuBar;



/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
/**
 * Main frame for the game location editor
 * @author Frank Bruns
 *
 */
public class MainFrame extends JFrame {

	private JMenuItem helpMenuItem;
	private JMenu jMenu5;
	private JMenu jMenu4;
	private JMenuItem exitMenuItem;
	private JSeparator jSeparator2;
	private JMenuItem closeFileMenuItem;
	private JMenuItem saveAsMenuItem;
	private JMenuItem saveMenuItem;
	private JMenuItem openFileMenuItem;
	private BasicLevelConfigPanel basicLevelConfigPanel;
	private JButton buttonGenScript;
	private ExitsPanel exitsPanel;
	private HotspotsPanel hotspotsPanel;
	private JButton buttonGenXML;
	private JTabbedPane mainTabbedPane;
	private JMenuItem newFileMenuItem;
	private JMenu jMenu3;
	private JMenuBar jMenuBar1;
	
	public MainFrame() {
		super();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		initGUI();
	}
	
	private void initGUI() {
		try {
			GroupLayout thisLayout = new GroupLayout(
				(JComponent) getContentPane());
			getContentPane().setLayout(thisLayout);
			{
				mainTabbedPane = new JTabbedPane();
				{
					basicLevelConfigPanel = new BasicLevelConfigPanel();
					mainTabbedPane.addTab(
						"Basic",
						null,
						basicLevelConfigPanel,
						"Specifiy basic information for the game location");
					
					exitsPanel = new ExitsPanel();
					mainTabbedPane.addTab(
							"Exits",
							null,
							exitsPanel,
							"Specify information for the exits of the game location");
					
					hotspotsPanel = new HotspotsPanel(); 
					mainTabbedPane.addTab(
							"Hotspots",
							null,
							hotspotsPanel,
							"Specify information for the interactive hotspots of the game location");
				}
			}
			{
				buttonGenXML = new JButton();
				buttonGenXML.setText("Make XML");
				buttonGenXML.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent evt) {
						buttonGenXMLActionPerformed(evt);
					}
				});
			}
			{
				buttonGenScript = new JButton();
				buttonGenScript.setText("Make Script");
				buttonGenScript.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent evt) {
						buttonGenScriptActionPerformed(evt);
					}
				});
			}
			this.setSize(599, 411);
			{
				jMenuBar1 = new JMenuBar();
				setJMenuBar(jMenuBar1);
				{
					jMenu3 = new JMenu();
					jMenuBar1.add(jMenu3);
					jMenu3.setText("File");
					{
						newFileMenuItem = new JMenuItem();
						jMenu3.add(newFileMenuItem);
						newFileMenuItem.setText("New");
					}
					{
						openFileMenuItem = new JMenuItem();
						jMenu3.add(openFileMenuItem);
						openFileMenuItem.setText("Open");
					}
					{
						saveMenuItem = new JMenuItem();
						jMenu3.add(saveMenuItem);
						saveMenuItem.setText("Save");
					}
					{
						saveAsMenuItem = new JMenuItem();
						jMenu3.add(saveAsMenuItem);
						saveAsMenuItem.setText("Save As ...");
					}
					{
						closeFileMenuItem = new JMenuItem();
						jMenu3.add(closeFileMenuItem);
						closeFileMenuItem.setText("Close");
					}
					{
						jSeparator2 = new JSeparator();
						jMenu3.add(jSeparator2);
					}
					{
						exitMenuItem = new JMenuItem();
						jMenu3.add(exitMenuItem);
						exitMenuItem.setText("Exit");
					}
				}
				{
					jMenu4 = new JMenu();
					jMenuBar1.add(jMenu4);
					jMenu4.setText("Edit");
				}
				{
					jMenu5 = new JMenu();
					jMenuBar1.add(jMenu5);
					jMenu5.setText("Help");
					{
						helpMenuItem = new JMenuItem();
						jMenu5.add(helpMenuItem);
						helpMenuItem.setText("Help");
					}
				}
			}
						thisLayout.setHorizontalGroup(thisLayout.createSequentialGroup()
			    .addContainerGap()
			    .add(mainTabbedPane, GroupLayout.PREFERRED_SIZE, 433, GroupLayout.PREFERRED_SIZE)
			    .add(22)
			    .add(thisLayout.createParallelGroup()
			        .add(GroupLayout.LEADING, buttonGenXML, GroupLayout.PREFERRED_SIZE, 112, GroupLayout.PREFERRED_SIZE)
			        .add(GroupLayout.LEADING, buttonGenScript, GroupLayout.PREFERRED_SIZE, 112, GroupLayout.PREFERRED_SIZE))
			    .addContainerGap());
						thisLayout.setVerticalGroup(thisLayout.createSequentialGroup()
			    .addContainerGap()
			    .add(thisLayout.createParallelGroup()
			        .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			            .add(mainTabbedPane, GroupLayout.PREFERRED_SIZE, 328, GroupLayout.PREFERRED_SIZE)
			            .addContainerGap())
			        .add(GroupLayout.LEADING, thisLayout.createSequentialGroup()
			            .add(268)
			            .add(buttonGenXML)
			            .addPreferredGap(LayoutStyle.RELATED)
			            .add(buttonGenScript)
			            .addContainerGap(22, 22))));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * Generates the xml file for the game location by using the provided
	 * information from the GUI
	 * @param evt
	 */
	private void buttonGenXMLActionPerformed(ActionEvent evt) {
        LocationExporter locExporter = new LocationExporter(
        		basicLevelConfigPanel.getBasicGameLocation().getLocationFileName());
        
        locExporter.exportToXML(basicLevelConfigPanel.getBasicGameLocation(),
        		exitsPanel.getExitList(),hotspotsPanel.getHotspotList());
	}
	
	private void buttonGenScriptActionPerformed(ActionEvent evt) {
		String scriptText = "";		
		try
		{
			FileWriter writer = new FileWriter(this.basicLevelConfigPanel.getBasicGameLocation().getScriptFileName());
			
			// replace exits with items and characters later on
			for(Exit ex : this.exitsPanel.getExitList())
			{
				scriptText += "use_"+ex.getBshName()+"()\n{\n\n}\n\n";
			}
						
			writer.write(scriptText);
			writer.close();
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
