package editor.model;

/**
 * This class will be used by the gui to store information about an
 * interactive hotspot created with the editor
 * @author Frank Bruns
 *
 */
public class Hotspot
{
	private String name = "";
	private String bshName = "";
	private String x = "";
	private String y = "";
	private String width = "";
	private String height = "";
	
	/**
	 * Creates an interactive hotspot object for data storage purposes 
	 * for the editor
	 * @param name interactive hotspot name
	 * @param bshName interactive hotspot beanshell name
	 * @param x x coordinate
	 * @param y y coordinate
	 * @param width interactive hotspot width
	 * @param height interactive hotspot height
	 */
	public Hotspot(String name, String bshName, String x, String y, 
			String width, String height)
	{
		this.name = name;
		this.bshName = bshName;
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
	}

	/**
	 * Returns the beanshell name
	 * @return beanshell name
	 */
	public String getBshName()
	{
		return bshName;
	}

	/**
	 * Returns the height
	 * @return height
	 */
	public String getHeight()
	{
		return height;
	}

	/**
	 * Returns the name
	 * @return name
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * Returns the width
	 * @return width
	 */
	public String getWidth()
	{
		return width;
	}

	/**
	 * Returns the x coordinate
	 * @return x coordinate
	 */
	public String getX()
	{
		return x;
	}

	/**
	 * Returns the y coordinate
	 * @return y coordinate
	 */
	public String getY()
	{
		return y;
	}
}
