/**
 * 
 */
package gameaction;

import java.awt.image.BufferedImage;

import location.InteractiveHotspot;

import gameobjects.characters.AbstractCharacterSprite;

/**
 * This class represents a game action that can be used to change/set the 
 * image assigned to an interactive hotspot 
 * @author Frank Bruns
 *
 */
public class ChangeHotspotImage extends AbstractGameAction
{
	private String imgPath = "no path to image yet";
	private InteractiveHotspot ihs = null;
	
	public ChangeHotspotImage(AbstractCharacterSprite c, InteractiveHotspot ihs, String imgPath)
	{
		super(c);
		this.imgPath = imgPath;
		this.ihs = ihs;
	}
	
	@Override
	public void update(long elapsedTime)
	{
		this.ihs.setImage(this.imgPath);
		this.character.getGameActionScheduler().removeFirst();
	}

}
