package gameaction;

import java.awt.Graphics2D;

import location.GameLocation;
import state.GameState;
import gameobjects.characters.AbstractCharacterSprite;
import gameobjects.characters.Player;

/**
 * This class represents a game action that stops a cutscene
 * @author Frank Bruns
 *
 */
public class CutSceneStop extends AbstractGameAction
{
private GameLocation location = null;
	
	public CutSceneStop(AbstractCharacterSprite c, GameLocation location)
	{
		super(c);
		this.location = location;
	}
	
	@Override
	public void update(long elapsedTime)
	{				
		if(this.secondMethodCall == true)
		{												
			this.character.getGameActionScheduler().removeFirst();
			//GameState.setState(GameState.NORMAL);
		}
		else
		{
			this.secondMethodCall = true;
			GameState.setState(GameState.TRANSITION_FROM_CUTSCENE);
			this.character.getGameLocation().setActive(false);
			this.location.setActive(true);
			// restore old background music, if neccessary
			if(this.location.getPlayingMusic().equals(this.location.getMusicFileName()) == false)
			this.location.playMusic(true);
		}
	}

	/**
	 * Renders a black screen for the first update() loop.
	 * @param g
	 */
	public void render(Graphics2D g)
	{
		if(this.secondMethodCall == false)
			g.fillRect(0, 0, 1024, 768);
	}
	
}
