package gameaction;

import gameobjects.characters.Player;
import gameobjects.item.Item;

/**
 * A game action that represents picking an item in the game location
 * @author Frank Bruns
 *
 */
public class Pick extends AbstractGameAction
{
	private Item item = null;
	
	/**
	 * A game action that represents picking an item
	 * in the game location
	 * @param player the player object that picks the item
	 * @param item the item that shall be picked
	 *
	 */
	public Pick(Player player, Item item)
	{
		super(player);		
		this.item = item;
	}

	@Override
	public void update(long elapsedTime)
	{	
		Player player = (Player)this.getCharacter();
		if(this.item.isPicked() == false)
		{			
			player.getAnimScheduler().clear();
			player.getAnimScheduler().add("pick", 1000);
			player.pickItem(this.item);				
		}		
		else player.getGameActionScheduler().clear();
	}

}
