/**
 * 
 */
package gameaction;

import java.awt.image.BufferedImage;

import location.InteractiveHotspot;

import gameobjects.characters.AbstractCharacterSprite;
import gameobjects.item.Item;

/**
 * This class represents a game action that can be used to change/set the 
 * pickability status of an item
 * @author Frank Bruns
 *
 */
public class SetItemPickable extends AbstractGameAction
{
	private boolean pickable = false;
	private Item item = null;
	
	public SetItemPickable(AbstractCharacterSprite c, Item item, boolean pickable)
	{
		super(c);
		this.pickable = pickable;
		this.item = item;
	}
	
	@Override
	public void update(long elapsedTime)
	{
		this.item.setPickable(this.pickable);
		this.character.getGameActionScheduler().removeFirst();
	}

}
