/**
 * 
 */
package gameaction;

import java.awt.image.BufferedImage;

import location.InteractiveHotspot;

import gameobjects.characters.AbstractCharacterSprite;
import gameobjects.item.Item;

/**
 * This class represents a game action that can be used to change/set the 
 * visibility status of an item
 * @author Frank Bruns
 *
 */
public class SetItemVisible extends AbstractGameAction
{
	private boolean visible = false;
	private Item item = null;
	
	public SetItemVisible(AbstractCharacterSprite c, Item item, boolean visible)
	{
		super(c);
		this.visible = visible;
		this.item = item;
	}
	
	@Override
	public void update(long elapsedTime)
	{
		this.item.setVisible(this.visible);
		this.character.getGameActionScheduler().removeFirst();
	}

}
