package gameobjects.prop;

import com.golden.gamedev.engine.BaseAudio;
import com.golden.gamedev.engine.BaseInput;
import com.golden.gamedev.engine.BaseLoader;

import gameobjects.AbstractGameObject;

/**
 * This class represents a simple game object that can be
 * placed into a game location. The characters can walk
 * in front and behind of it, but they cannot interact with it.
 * @author Frank Bruns
 *
 */
public class Prop extends AbstractGameObject
{

	/**
	 * Creates a new prop game object. It is initialized with
	 * an empty String as its name. Therefore a name cannot be
	 * displayed while moving the mouse over it.
	 * @param bshName beanshell name of the prop
	 * @param x x coordinate
	 * @param y y coordinate
	 * @param bsLoader
	 * @param bsInput
	 * @param bsSound
	 */
	public Prop(String bshName, double x, double y,
			BaseLoader bsLoader, BaseInput bsInput, BaseAudio bsSound)
	{
		super("", bshName, x, y, bsLoader, bsInput, bsSound);		
	}

}
