package cursor;

import java.awt.image.BufferedImage;
import com.golden.gamedev.object.Sprite;

/**
 * This class represents a game cursor that is based on an animated sprite 
 * @author Frank Bruns
 *
 */
public class GameCursor extends Sprite
{
	private String constant = "";
	private BufferedImage icon = null;
	
	/**
	 * Creates a new game cursor with the specified parameters
	 * @param constant cursor constant like Cursors.TALK
	 * @param icon icon to use for the cursor
	 */
	public GameCursor(String constant, BufferedImage icon)
	{
		this.constant = constant;
		this.icon = icon;
		this.setImage(icon);
	}
	
	/**
	 * Returns the constant of this cursor
	 * @return cursor constant
	 */
	public String getConstant()
	{
		return this.constant;
	}
}
