package editor.model;


/**
 * This class will be used by the gui to store basic information about a
 * a game location created with the editor
 * @author Frank Bruns
 *
 */
public class BasicGameLocation
{
	String fileName = "";
	String name = "";
	String bshName = "";
	String scriptFile = "";
	String bgImgFile = "";
	String bgMusicFile = "";
	
	public BasicGameLocation(String fileName, String name, String bshName, 
			String scriptFile, String bgImgFile, String bgMusicFile)
	{
		this.fileName = fileName;
		this.name = name;
		this.bshName = bshName;
		this.scriptFile = scriptFile;
		this.bgImgFile = bgImgFile;
		this.bgMusicFile = bgMusicFile;
	}
	
	/**
	 * Returns the file name for the game location's xml file
	 * @return file name for the xml file
	 */
	public String getLocationFileName()
	{
		return this.fileName;
	}
	
	/**
	 * Return the name for game location
	 * @return name for game location
	 */
	public String getLocationName()
	{
		return this.name;
	}
	
	/**
	 * Return the beanshell name for the game location
	 * @return beanshell name for the game location
	 */
	public String getLocationBshName()
	{
		return this.bshName;
	}
	
	/**
	 * Returns the script file name for the game location
	 * @return script file name for the game location
	 */
	public String getScriptFileName()
	{
		return this.scriptFile;
	}
	
	/**
	 * Returns the file name of the background image of the game location
	 * @return file name of the background image
	 */
	public String getBGImageFileName()
	{
		return this.bgImgFile;
	}
	
	/**
	 * Returns the file name of the music file for the game location
	 * @return file name of the music file
	 */
	public String getMusicFileName()
	{
		return this.bgMusicFile;
	}
}
