package gameaction;

import gameobjects.characters.AbstractCharacterSprite;

/**
 * This game action class can be used to put a delay of
 * the specified amount of miliseconds to the processing
 * of a character'S game action queue
 * @author John Rico
 *
 */
public class Delay extends AbstractGameAction
{
	private long startTime = 0;
	private long duration = 0;

	public Delay(AbstractCharacterSprite c, long duration)
	{
		super(c);
		this.duration = duration;
	}
	
	@Override
	public void update(long elapsedTime)
	{
		// init start time once
		if(this.startTime == 0)
		{			
			this.startTime = System.currentTimeMillis();			
		}
		
		if(System.currentTimeMillis() - this.startTime >= this.duration)
		{		
			System.out.println("[Delay] time: "+(System.currentTimeMillis() - this.startTime));
			this.character.getGameActionScheduler().removeFirst();	
		}		
	}

}
