package gameaction;

import gameobjects.characters.AbstractCharacterSprite;
import location.LocationExit;

/**
 * A game action that represents leaving a game location
 * @author Frank Bruns
 *
 */
public class Leave extends AbstractGameAction
{
	private LocationExit exit = null;
	
	public Leave(AbstractCharacterSprite c, LocationExit exit)
	{
		super(c);
		this.exit = exit;
	}
	
	@Override
	public synchronized void update(long elapsedTime)
	{
		if(this.character.hasJustUsedExit() == false)
		{
			this.exit.use(this.character);
		}
		
		else 
		{
			this.character.getAnimScheduler().clear();
			this.character.getGameActionScheduler().clear();
			this.character.setJustUsedExit(false);
		}
		
	}
}
