package gameaction;

import gameobjects.characters.AbstractCharacterSprite;

/**
 * This class represents a game action that is responsible for
 * showing a simple intermission screen
 * @author Frank Bruns
 *
 */
public class ShowIntermissionScreen extends AbstractGameAction
{
	long duration = 0;
	long startTime = 0;
	String imgPath = "no image path yet";	
	
	public ShowIntermissionScreen(AbstractCharacterSprite c, String imgPath, long duration)
	{
		super(c);
		this.duration = duration;
		this.imgPath = imgPath;
	}

	@Override
	public void update(long elapsedTime)
	{
		// init start time once
		if(this.startTime == 0)
		{
			//System.out.println("[ShowIntermissionScreen] ich war hier");
			this.startTime = System.currentTimeMillis();
			this.character.getGameLocation().setIntermissionScreenEnabled(this.imgPath);
		}
		
		if(System.currentTimeMillis() - this.startTime >= this.duration)
		{			
			this.character.getGameLocation().setIntermissionScreenDiabled();
			this.character.getGameActionScheduler().removeFirst();	
		}
	}

}
