package gameobjects.characters;

import java.awt.Color;

import com.golden.gamedev.engine.BaseAudio;
import com.golden.gamedev.engine.BaseInput;
import com.golden.gamedev.engine.BaseLoader;

/**
 * This class is the base class of all non player characters. Please
 * extend this class to create your actual non player characters
 * @author Frank Bruns
 *
 */
public class NPCSprite extends AbstractCharacterSprite
{
	/**
	 * Creates a new non player character sprite.
	 * @param name Name of the character
	 * @param bshName name that will be used for this character in
	 * beanshell scripts
	 * @param x x-coordinate, where the sprite should initially appear
	 * @param y y-coordinate, where the sprite should initially appear
	 * @param speachColor color for the spoken dialog lines on screen
	 * @param bsLoader the BaseLoader object from the Main class
	 * @param bsSound the BaseAudio object from the Main class
	 * @param bsInput the BaseInput object from the Main class
	 */
	public NPCSprite(String name, String bshName, double x, double y, Color speachColor, BaseLoader bsLoader, BaseInput bsInput, BaseAudio bsSound)
	{
		super(name,bshName,x,y,speachColor,bsLoader,bsInput,bsSound);
	}
}
